require("fast-xml-parser")
var nodeFints = require("node-fints")
var moment = require("moment")

function getAccountStatements( client, accounts, statements, callback ) {
  for ( let i in accounts ) {
    let account = accounts[i]

    if ( !account.hasOwnProperty( "statementsIsSet" ) || (account.hasOwnProperty( "statementsIsSet" ) && !account.statementsIsSet) ) {
      client
        .statements( account, new Date( moment().subtract( 1, 'day' ).startOf( 'day' ) ), new Date() )
        .then( function( statementsBack ) {
          statements.push( statementsBack )
          account.statementsIsSet = true
          account.statements = ((statementsBack.length > 0) ? statementsBack[0] : {})
          let accountsFilter = accounts.filter( function( account ) {
            return (account.hasOwnProperty( "statementsIsSet" ))
          } )
          if ( accountsFilter.length === accounts.length ) {
            callback( statements, accounts )
            return
          } else {
            getAccountStatements( client, accounts, statements, callback )
          }
        } );
      break
    }
  }
}


const client = new nodeFints.PinTanClient( {
                                   url: "https://fints.norisbank.de/",
                                   name: "5585",//kontonummer 
                                   pin: "1235",
                                   blz: "123456",
                                 } );
let fintsObject = {
  accounts: null,
  statements: null
}
client.accounts().then( function( accounts ) {
  fintsObject.accounts = accounts
  getAccountStatements( client, accounts, [], ( statements, accountsBack ) => {
    fintsObject.statements = statements;

    console.log( fintsObject );
  } )
} ).catch( ( error ) => {
  console.log( error );
} );